
QGIS Application - Bug report #14524

linestring shapefile with geometry errors disappear from map canvas

2016-03-17 11:50 PM - aperi2007 -

Status: Closed

Priority: Normal

Assignee:

Category: Map Canvas

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: end of life

Crashes QGIS or corrupts data:No Copied to github as #: 22497

Description

We have a line shapefile produced with qgis with some strange issue. When add it to a new empty qgis project and show at  full extent it is

visible. Instead, when zoom at details it simply disappear.

I never seen this before.

The shapefile is with 1 only records multilinestring. Obtained manually from we with many day of editing work at big details (about 1:2000)

and after this dissolved into 1 only geometry with many parts. After this dissolve it work again for some day, where we apply others

editing. And yesterdays we dont know we it start to do this strange disappearing at the details level.

The work was done on qgis 2.12 32bit, but it is disappearing also on qgis 2.14 32bit. We use windows 7.

The package has 2 qgis project. The first show the shapefile at full extent and is visible. The second try to show the shapefile at details

level and it is not visible.

History

#1 - 2016-03-18 02:59 AM - Jürgen Fischer

Does it also happen if you remove the qix (or rebuild it)?

#2 - 2016-03-18 03:25 AM - aperi2007 -

Yes,

it happen also if removing the .qix.

I dont know how to rebuild it (the qix).

#3 - 2016-03-18 03:44 AM - aperi2007 -

- File new_shapefile_crashing.7z added

I try to resolve the issue loading it on spatialite and doing a ST_MAkeValid to resolve all the invalidity of the shapefile.

The spatialite report me that the invalidity are resolved. And after this try to load it on QGIS (2.1) but still it disappear when zoom at detail level.

So I try to analyze it using the QGIS check geometry validity, but when click OK the qgis will crash.
I add this new shapefile to this ticket.

#4 - 2016-03-18 11:13 AM - Maximilian Krambach

I tried "new_shapefile_crashing" and could check for validity using the python console. The toolbox geometry validity tool did not crash either (qgis 2.14).

The shape has 32 self-intersections, one line with less than two points, and 3 duplicate nodes.

The real issue seems to be "invalid geometries are not displayed when zoomed in more than their extend", thus making it impossible to repair them. The

crash might be another issue.

#5 - 2016-03-21 11:46 PM - aperi2007 -

Are you say-ing that qgis dont display an invalid geometry when it is invalid ?

I dont know this

Maximilian Krambach wrote:

I tried "new_shapefile_crashing" and could check for validity using the python console. The toolbox geometry validity tool did not crash either (qgis

2.14). The shape has 32 self-intersections, one line with less than two points, and 3 duplicate nodes.

The real issue seems to be "invalid geometries are not displayed when zoomed in more than their extend", thus making it impossible to repair them.

The crash might be another issue.

#6 - 2016-03-22 02:00 AM - Jürgen Fischer

- Subject changed from Strange disappearing of a linestrin shapefile geometry to Strange disappearing of a linestring shapefile geometry

#7 - 2016-03-22 02:56 PM - Maximilian Krambach

When testing with other invalid lines (self intersection, lines with 0 or 1 points), they don't disappear. So I'm unsure now what causes the line to disappear.

However, your data give a "Exception: IllegalArgumentException: point array must contain 0 or >1 elements" message in the GEOS log. Maybe this will

help someone to find the cause.

To repair your data, you can use the "v.clean" (grass) tool. They wil be multiple lines again, but your work won't be lost.

#8 - 2016-03-23 03:55 PM - aperi2007 -

Thx for your feedback.

I really appreaciate the time you lost try-ing to be of help for us.

Unfortunatelly we was not able to start the grass from inside our qgis installation.

I'm really embarrassed to be unable to try the solution you (with your time) give us due to another annoying issue in our installations of qgis.

(sometimes qgis is really irritating)

So I cannot verify your solution using Grass tools v.clean.

So we try to resolve the invalidities using other solutions.
A.

Maximilian Krambach wrote:

When testing with other invalid lines (self intersection, lines with 0 or 1 points), they don't disappear. So I'm unsure now what causes the line to

disappear. However, your data give a "Exception: IllegalArgumentException: point array must contain 0 or >1 elements" message in the GEOS log.

Maybe this will help someone to find the cause.

To repair your data, you can use the "v.clean" (grass) tool. They wil be multiple lines again, but your work won't be lost.

#9 - 2016-03-24 05:34 AM - Maximilian Krambach

I investigated it further.

The culprit in the shapefile is a (somehow valid) line with a length of < 1e-10 m. The multipart geometry apparently cannot handle this level of detail

difference. The shapefile is okay, just the display is off. To "repair" the shapefile, run "multipart to singlepart", then find the offending feature id, delete this

feature and proceed with "singlepart to multipart" again.

To find the feature id, you can run a small code snippet on the python console (extensions- python console):

layer = iface.activeLayer()

for feature in layer.getFeatures():

    if feature.geometry().length() < 0.0000000001: 

        print feature.id()

#10 - 2016-04-09 10:59 AM - Giovanni Manghi

- Status changed from Open to Feedback

where do we stand with this issue?

#11 - 2016-05-23 08:29 AM - Giovanni Manghi

sorry for asking asking again, what is the status of this issue? Has the reporter made more tests?

#12 - 2016-07-03 09:44 AM - Giovanni Manghi

- Subject changed from Strange disappearing of a linestring shapefile geometry to linestring shapefile with geometry errors disappear from map canvas

- Status changed from Feedback to Open

- Affected QGIS version changed from 2.14.0 to master

Other software is affected (ex: OpenJump), other no (ex: gvSIG).

It seems that the crash while checking the layer with the QGIS tool is gone in the latest releases.

Also cleaning with Processing/GRASS produces a working vector.

It would be anyway good to at least ẁarn the users about what is going on with such vectors.
#13 - 2017-05-01 01:05 AM - Giovanni Manghi

- Easy fix? set to No

- Regression? set to No

#14 - 2019-03-09 04:10 PM - Giovanni Manghi

- Status changed from Open to Closed

- Resolution set to end of life

End of life notice: QGIS 2.18 LTR

Source:

http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-ltr/

Files

disappearing-issue.7z 317 KB 2016-03-17 aperi2007 -

new_shapefile_crashing.7z 304 KB 2016-03-18 aperi2007 -
